#include <stdio.h>
#include <stdlib.h>

#define MAX_n 10
#define INF 1000000

int min (int a, int b) {
  return (a <= b ? a : b);
}

void cargar_grafo (char * argv[], int m[][MAX_n], int n) {
  int i, j, k;
  k = 1;
  for (i = 0; i < n; i++) {
    for (j = 0; j < n; j++) {
      m[i][j] = atoi(argv[k]);
      if (m[i][j] == -1) m[i][j] = INF;
      k++;
    }
  }
}

void floyd (int m[][MAX_n], int n) {
  int i, j, k;

  for (k = 1; k < n; k++) {
    for (i = 0; i < n; i++) {
      for (j = 0; j < n; j++) {
        m[i][j] = min(m[i][j],m[i][k]+m[k][j]);
      }
    }
  }
}

void escribir (int m[][MAX_n], int n) {
  int i, j;

  for (i = 0; i < n; i++) {
    for (j = 0; j < n; j++) {
      printf("%d -> %d : %d\n",i+1,j+1,m[i][j]);
    }
  }
}

int main (int argc, char *argv[]) {
  int m[MAX_n][MAX_n];

  int n = atoi(argv[argc-1]);
  printf("n = %d\n",n);

  if (argc != n*n + 2) {
    printf("Wrong number of arguments.\n");
    return 1;
  }

  cargar_grafo(argv,m,n);
  floyd(m,n);
  escribir(m,n);

  return 0;
}

// ./dinamica 0 4 1 10 -1 -1 4 0 3 -1  1 -1 -1 2 0 8 4 -1 2 -1  2 0 -1 -1 -1 -1 3 -1 0 3  -1 -1 2 1 -1 0 6
