#include <stdio.h>
#include <stdlib.h>

#define MAX_n 10
#define INF 1000000

int min (int a, int b) {
  return (a <= b ? a : b);
}

void cargar_grafo (char * argv[], int m[][MAX_n], int n) {
  int i, j, k;
  k = 1;
  for (i = 0; i < n; i++) {
    for (j = 0; j < n; j++) {
      m[i][j] = atoi(argv[k]);
      if (m[i][j] == -1) m[i][j] = INF;
      k++;
    }
  }
}

void inicializar (int via[][MAX_n], int n) {
  int i, j;

  for (i = 0; i < n; i++) {
    for (j = 0; j < n; j++) via[i][j] = 0;
  }
}

void floyd (int via[][MAX_n], int m[][MAX_n], int n) {
  int i, j, k, costo_via_k;

  inicializar(via,n);

  for (k = 1; k < n; k++) {
    for (i = 0; i < n; i++) {
      for (j = 0; j < n; j++) {
        costo_via_k = m[i][k]+m[k][j];
        if (costo_via_k < m[i][j]) {
          m[i][j] = costo_via_k;
          via[i][j] = k;
        }
      }
    }
  }
}

void escribir_intermedios (int via[][MAX_n], int i, int j) {
  int k = via[i][j];
  if (k != 0) {
    escribir_intermedios(via,i,k);
    printf("%d, ",k+1);
    escribir_intermedios(via,k,j);
  }
}


void escribir (int via[][MAX_n], int m[][MAX_n], int n) {
  int i, j;

  for (i = 0; i < n; i++) {
    for (j = 0; j < n; j++) {
      printf("%d -> %d : %d = [%d, ",i+1,j+1,m[i][j],i+1);
      escribir_intermedios(via,i,j);
      printf("%d]\n",j+1);
    }
  }
}

int main (int argc, char *argv[]) {
  int m[MAX_n][MAX_n];
  int via[MAX_n][MAX_n];

  int n = atoi(argv[argc-1]);
  printf("n = %d\n",n);

  if (argc != n*n + 2) {
    printf("Wrong number of arguments.\n");
    return 1;
  }

  cargar_grafo(argv,m,n);
  floyd(via,m,n);
  escribir(via,m,n);

  return 0;
}

// ./dinamica 0 4 1 10 -1 -1 4 0 3 -1  1 -1 -1 2 0 8 4 -1 2 -1  2 0 -1 -1 -1 -1 3 -1 0 3  -1 -1 2 1 -1 0 6
